/*
 * ELevel - Compression Library for Super Mario Advance 4 eCard levels
 * Copyright(c) 2003 Parasyte and Bouche
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <windows.h>
#include <stdio.h>
#include <string.h>

#include "types.h"

#define DLLVERSION 0x0001

u32 WINAPI ELevelVersion();
u32 WINAPI ELevelGetDecmpSize(u8 *src);
u32 WINAPI ELevelDecmp(u8 *src, u8 *dest);



//blah blah, useless in our case, include anyway....
BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved) {
	switch (fdwReason) {
		case DLL_PROCESS_ATTACH:
			// Code to run when the DLL is loaded
			break;
		case DLL_PROCESS_DETACH:
			// Code to run when the DLL is freed
			break;
		case DLL_THREAD_ATTACH:
			// Code to run when a thread is created during the DLL's lifetime
			break;
		case DLL_THREAD_DETACH:
			// Code to run when a thread ends normally
			break;
	}
	return TRUE;
}

u32 WINAPI ELevelVersion() {
	return DLLVERSION;
}

u32 WINAPI ELevelGetDecmpSize(u8 *src) {
	return (src[5] << 0x10) | (src[6] << 8) | src[7];
}

u32 WINAPI ELevelDecmp(u8 *src, u8 *dest) {
	u32 i;
	u32 count = 0;
	u32 len = ELevelGetDecmpSize(src);
	u32 tmp4 = (src[8] << 0x18) | (src[9] << 0x10) | (src[10] << 8) | src[11];

	u32 temp1 = 0x0200;
	u32 temp2 = 12;
	u32 temp3 = 0xFFFFFFFF;
	u32 temp4 = 0xFFFFFFFF;
	u32 temp5 = 0;
	u32 temp6 = 0;

	u32 tarray3[0x0200];
	u32 tarray[0x0201];
	u32 tarray4[0x1000];
	u32 tarray2[0x1001];

	u32 buffer1;
	u32 buffer2;

	u32 shitvar;
	u32 var;
	u32 someshit;
	u32 wtfshit;
	s32 wtfshit2;

	u32 tmpr0;
	u32 tmpr1;


	if (src[4] & 0x80) temp1 = 0x1000;

	//setup the buffer table thingies!
	tarray[0] = 0;
	for (i = 0; i < 0x0200; i++) {
		tarray3[i] = 1;
		tarray[i+1] = (tarray[i] + 1);
	}
	tarray2[0] = 0;
	for (i = 0; i < temp1; i++) {
		tarray4[i] = 1;
		tarray2[i+1] = (tarray2[i] + 1);
	}

	//fill initial input buffers
	buffer1 = (src[temp2] << 0x18) | (src[temp2+1] << 0x10) | (src[temp2+2] << 8) | src[temp2+3];
	buffer2 = (src[tmp4] << 0x18) | (src[tmp4+1] << 0x10) | (src[tmp4+2] << 8) | src[tmp4+3];
	temp2 += 4;
	tmp4 += 4;

	while (count < len) {
		//printf("count: %d  len: %d\n",count,len);
		shitvar = (tarray[0x0200] ? (temp4 / tarray[0x0200]) : 0);
		var = (shitvar ? ((buffer1 - temp6) / shitvar) : 0);
		someshit = 0;
		wtfshit = 0x0200;

		while (someshit < wtfshit) {
			wtfshit2 = (someshit + wtfshit) / 2;
			if (var < tarray[wtfshit2])
				wtfshit = wtfshit2;
			else
				someshit = wtfshit2 + 1;
		}

		while (wtfshit2 >= 0) {
			if ((tarray[wtfshit2] <= var) && (tarray[wtfshit2+1] > var)) break;
			wtfshit2--;
		}

		temp6 += (tarray[wtfshit2] * shitvar);
		temp4 = (tarray3[wtfshit2]++ * shitvar);

		for (i = (wtfshit2+1); i <= 0x0200; i++)
			tarray[i]++;
		if (tarray[0x0200] > 0xFFFF) {
			tarray[0] = 0;
			i = 0;
			while (i++ < 0x0200) {
				tarray3[i] = (tarray3[i] << 1) | 1;
				tarray[i+1] = (tarray[i] + tarray3[i]);
			}
		}
		while ((temp6 & 0xFF000000) == ((temp6 + temp4) & 0xFF000000)) {
			buffer1 = ((buffer1<<8) | src[temp2++]);
			temp6 <<= 8;
			temp4 <<= 8;
		}
		while (temp4 < 0x10000) {
			temp4 = (0x10000 - (temp6 & 0xFFFF)) << 8;
			buffer1 = (buffer1<<8) | src[temp2++];
			temp6 <<= 8;
		}

		if (wtfshit2 < 0x100)
			dest[count++] = wtfshit2;
		else {
			shitvar = (tarray2[temp1] ? (temp3 / tarray2[temp1]) : 0);
			var = (shitvar ? ((buffer2 - temp5) / shitvar) : 0);
			someshit = 0;
			wtfshit = temp1;

			while (someshit < wtfshit) {
				tmpr1 = (someshit + wtfshit) / 2;
				if (var < tarray2[tmpr1])
					wtfshit = tmpr1;
				else
					someshit = (tmpr1 + 1);
			}

			while (tmpr1 >= 0) {
				if ((tarray2[tmpr1] <= var) && (tarray2[tmpr1+1] > var)) break;
				tmpr1--;
			}
			tmpr0 = (count-tmpr1-1);

			for (i = (wtfshit2 - 0xFD); i > 0; i--)
				dest[count++] = dest[tmpr0++];

			temp5 += (tarray2[tmpr1] * shitvar);
			temp3 = (tarray4[tmpr1]++ * shitvar);
			for (i = (tmpr1+1); i <= temp1; i++)
				tarray2[i]++;

			if (tarray2[temp1] > 0xFFFF) {
				tarray2[0] = 0;
				i=0;
				while (i++ < temp1) {
					tarray4[i] = (tarray4[i] << 1) | 1;
					tarray2[i+1] = (tarray2[i] + tarray4[i]);
				}
			}

			while ((temp5 & 0xFF000000) == ((temp5+temp3) & 0xFF000000)) {
				buffer2 = (buffer2 << 8) | src[tmp4++];
				temp5 <<= 8;
				temp3 <<= 8;
			}
			while (temp3 < 0x10000) {
				temp3 = (0x10000 - (temp5 & 0xFFFF)) << 8;
				buffer2 = (buffer2 << 8) | src[tmp4++];
				temp5 <<= 8;
			}
		}
	}

	return count;
}
